!=========================================================================
! Copyright (C) GemTalk Systems 2013-2017.  All Rights Reserved.
!=========================================================================

category: 'Index Query Support'
set compile_env: 0
method: Array
buildGsQueryParserNodeFor: aGsQueryParser
  | receiverNode messages |
  receiverNode := self at: 1.
  messages := self at: 2.
  aGsQueryParser build: receiverNode messages: messages
%
category: 'Testing'
set compile_env: 0
method: Array
_literalEqual: anotherLiteral
  "For two literals to be _literalEqual, their class must be identical and  
   otherwise equal"

  self class == anotherLiteral class
    ifFalse: [ ^ false ].
  self size == anotherLiteral size
    ifFalse: [ ^ false ].
  self
    with: anotherLiteral
    do: [ :e1 :e2 | 
      (e1 _literalEqual: e2)
        ifFalse: [ ^ false ] ].
  ^ true
%
category: 'Testing'
method: Array
_refersToLiteral: literal
  "Answer true if literal is identical to any literal in receiver, even if imbedded 
   in further structures."  
  1 to: self size do: [ :index | 
    | lit |
    (literal _literalEqual: (lit := self at: index))
      ifTrue: [ ^ true ].
    (lit _refersToLiteral: literal)
      ifTrue: [ ^ true ] ].
  ^ false
%
category: 'Testing'
method: Array
_refersToNonSymbolLiteral: literal
  "Answer true if literal is equivalent to any non-symbol element of receiver. 
   Used by ClassOrganizer. 
   If literal is a SymbolAssociation, the value of literal is used.
   If literal is an Array,  elements of literal are searched ." 

  1 to: self size do: [ :index | 
    | lit |
    (lit := self at: index ) _isSymbol ifFalse:[
      (literal _literalEqual: lit ) ifTrue: [ ^ true ].
      lit _isArray ifTrue:[
        (lit _refersToNonSymbolLiteral: literal) ifTrue: [ ^ true ] 
      ] ifFalse:[ | a b |
        ((a := lit) isKindOfClass: SymbolAssociation) ifTrue:[ a := a _value ].
        ((b := literal) isKindOfClass: SymbolAssociation) ifTrue:[ b := b _value ].
        a == b ifTrue:[ ^ true ].
      ]
    ]
  ].
  ^ false
%

